#ifndef INDIVIDUAL_H
#define INDIVIDUAL_H

#include <vector>
#define PI 3.1415926535897932385
#define E 2.7182818284590452354
#define MAX 32.768
#define MIN -32.768

using namespace std;

class Individual
{
private:
	vector<double> genotype;												// genotype
	double _fitness;														// internal fitness value must be reevaluated on construction or mutation
	double randomDouble(double _minValue = MIN, double _maxValue = MAX);	// generate random doubles between any two doubles
	void fitness();															// evaluate fitness
	static const int defaultMaxSize = 20;									// default maximum genotype size

public:
	Individual();							// default constructor creates Individual with random size genotype up to defaultMaxSize
	Individual(int);						// constructor with specified genotype size
	Individual(vector<double>);				// constructor creates Individual with specified genotype
	~Individual();							// destructor
	double getFitness();					// return fitness
	int getSize();							// return genotype size
	void printInd();						// print genotype
};

#endif